//CNC v3.2.2
//Build instruction on:
//https://homofaciens.de/technics-machines-cnc-v3-2-2_en.htm

$fn=100;
//Colors
wood_r = 0.76;
wood_g = 0.64;
wood_b = 0.0;

metal_r = 0.7;
metal_g = 0.7;
metal_b = 0.7;

c_1 = [wood_r, wood_g, wood_b, 1.0];
c_2 = [wood_r, wood_g, wood_b, 1.0];
c_3 = [wood_r, wood_g, wood_b, 1.0];
c_4 = [wood_r, wood_g, wood_b, 1.0];
c_5 = [wood_r, wood_g, wood_b, 1.0];
c_6 = [wood_r, wood_g, wood_b, 1.0];
c_7 = [wood_r, wood_g, wood_b, 1.0];
c_8 = [wood_r, wood_g, wood_b, 1.0];
c_9 = [wood_r, wood_g, wood_b, 1.0];
c_10 = [wood_r, wood_g, wood_b, 1.0];
c_11 = [wood_r, wood_g, wood_b, 1.0];
c_12 = [wood_r, wood_g, wood_b, 1.0];
c_13 = [wood_r, wood_g, wood_b, 1.0];
c_14 = [wood_r, wood_g, wood_b, 1.0];
c_15 = [wood_r, wood_g, wood_b, 1.0];
c_16 = [wood_r, wood_g, wood_b, 1.0];
c_17 = [wood_r, wood_g, wood_b, 1.0];
c_18 = [metal_r, metal_g, metal_b, 1.0];
c_19 = [metal_r, metal_g, metal_b, 1.0];
c_20 = [metal_r, metal_g, metal_b, 1.0];
c_21 = [metal_r, metal_g, metal_b, 1.0];
c_22 = [metal_r, metal_g, metal_b, 1.0];
c_23 = [metal_r, metal_g, metal_b, 1.0];
c_24 = [metal_r, metal_g, metal_b, 1.0];
c_25 = [wood_r, wood_g, wood_b, 1.0];
c_26 = [wood_r, wood_g, wood_b, 1.0];
c_27 = [metal_r, metal_g, metal_b, 1.0];
c_28 = [metal_r, metal_g, metal_b, 1.0];
c_29 = [metal_r, metal_g, metal_b, 1.0];
c_30 = [metal_r, metal_g, metal_b, 1.0];
c_31 = [metal_r, metal_g, metal_b, 1.0];
c_32 = [metal_r, metal_g, metal_b, 1.0];
c_33 = [metal_r, metal_g, metal_b, 1.0];
c_34 = [wood_r, wood_g, wood_b, 1.0];
c_35 = [metal_r, metal_g, metal_b, 1.0];
c_36 = [metal_r, metal_g, metal_b, 1.0];
c_37 = [metal_r, metal_g, metal_b, 1.0];
c_38 = [metal_r, metal_g, metal_b, 1.0];
c_39 = [metal_r, metal_g, metal_b, 1.0];
c_40 = [wood_r, wood_g, wood_b, 1.0];
c_41 = [metal_r, metal_g, metal_b, 1.0];
c_42 = [metal_r, metal_g, metal_b, 1.0];
c_43 = [metal_r, metal_g, metal_b, 1.0];
c_44 = [metal_r, metal_g, metal_b, 1.0];
c_45 = [metal_r, metal_g, metal_b, 1.0];

thickness = 18;
l1 = 1000;  //Tower
l2 = 1000-2*thickness;   //Tower-thickness
l3 = 700;   //Socket, side panels tower
l4 = 400;  //Side panels top box
l5 = 570-thickness;  //Top panel top box
l6 = 270-thickness;  //Bottom panel top box
l7 = 300-2*thickness;  //Bottom panel top box
l8 = 1000; //Y table length
l9 = 100; //Y table ball bearing mounts
l10 = 40; //Enforcements X/Y-table
l11 = 240; //Z axis base plate
l12 = 150; //Z axis bearings mount
l13 = 400+2*thickness; //Z axis bearings mount
l14 = 450; //X-table
w1 = 300;
w2 = 150;
w3 = 200; //Base plate Z axis

enforce_w = 20;
enforce_h = 40;

bar_edge = 20;
bar_l1 = 700;
bar_l2 = l8;
bar_l3 = 450; //table crossbars
bar_l4 = 350; //table bars
bar_l5 = 400;  //Z axis guides on tower
bar_l6 = 520; //X table bearings mount
bar_l7 = 100; //Mounts lead "nuts"
bar_l8 = 300;  //Z axis guides
bar_l8 = l11;  //Z axis guides
bar_l9 = 430;  //Z axis guides
bar_l10 = 290; //Z axis center guide
bar_l11 = 200; //Mount Z motor
bar_l12 = 150; //Mount Z motor

//Bearings 10mm inner diameter
bearing10_d = 30;
bearing10_hole = 10;
bearing10_w = 9;

//Bearings 6mm inner diameter
bearing6_d = 19;
bearing6_hole = 6;
bearing6_w = 6;

hole_1 = 4;
hole_1_distance = 300/4;
hole_2 = 6;
hole_2_distance = 70;
hole_3 = 6;
hole_3_distance = bar_edge*1.5;
hole_4_distance = 67;

b_x1 = 11;
b_x2 = bearing10_w/2+11;
b_y2 = 25;
b_z1a = 59+bearing10_d/2;
b_z1b = b_z1a+bearing10_d+bar_edge;
b_z2a = 1;
b_z2b = b_z2a-bearing10_d-bar_edge;
b_z3a = 30;

x_bearing10_distance = 400-2*thickness;
y_bearing10_distance = 400;
y_x = 700;

table_bar_no = 14;

c_1 = [1.0, 0.0, 0.0, 1.0];


parts_visible_l = 34;
parts_visible_h = 39;

translate([150, 150, 0]){
  tower();

  translate([y_x, 0, 349]){
    y_table();
  }

  translate([y_x, -200, 416]){
    x_table();
  }

  translate([475, 0, 670]){
    z_table();
  }
}

module screw_holes(distance = 60,
                     length = 100,
                     pos = w1,
                     holes = 3,
                     diameter = hole_1,
                     flip = 0,
                     mirror = 0, 
                     extra_edge = 0,
                     skip =-1){
  edge = (length - (holes-1) * distance)/2 + extra_edge;
  for(i=[0:1:holes-1]){
    if(flip == 0 && i != skip){
      translate([length/2-edge-i*distance, pos, 0]){
        cylinder(d=diameter, h=thickness*10.1, center=true);
      }
      if(mirror == 1){
        translate([length/2-edge-i*distance, -pos, 0]){
          cylinder(d=diameter, h=thickness*10.1, center=true);
        }
      }
    }
    if(flip == 1 && i != skip){
      translate([pos, length/2-edge-i*distance, 0]){
        cylinder(d=diameter, h=thickness*10.1, center=true);
      }
      if(mirror == 1){
        translate([-pos, length/2-edge-i*distance, 0]){
          cylinder(d=diameter, h=thickness*10.1, center=true);
        }
      }
    }
  }
}

module tower(){
  //Socket base plate
  if(parts_visible_l <= 1 && parts_visible_h >= 1){
    color(c_2)
    translate([(l1-w1)/2, 0, thickness/2]){
      rotate([0, 0, 0]){
        difference(){
          cube(size=[l1, w1, thickness], center=true);
          screw_holes(distance = hole_1_distance,
                       length = w1,
                       pos = (l1-thickness)/2,
                       holes = 4,
                       diameter = hole_1,
                       flip = 1,
                       mirror = 1);
          screw_holes(distance = hole_1_distance,
                       length = w1,
                       pos = (l1)/2-350,
                       holes = 4,
                       diameter = hole_1,
                       flip = 1,
                       mirror = 0);
          screw_holes(distance = hole_1_distance,
                       length = w1,
                       pos = (l1-thickness)/2-700,
                       holes = 4,
                       diameter = hole_1,
                       flip = 1,
                       mirror = 0);
        }
      }
    }
  }
  //inserted panels socket
  if(parts_visible_l <= 2 && parts_visible_h >= 2){
    color(c_2)
    translate([l1-(w1+thickness)/2, 0, l7/2+thickness]){
      rotate([0, 90, 0]){
        difference(){
          cube(size=[l7, w1, thickness], center=true);
          rounded_square(150, 50, thickness*1.1);
        }
      }
    }
  }

  if(parts_visible_l <= 3 && parts_visible_h >= 3){
    color(c_3)
    translate([(l3+w1)/2, 0, l7/2+thickness]){
      rotate([0, 90, 0]){
        difference(){
          cube(size=[l7, w1, thickness], center=true);
          //translate([l7/2-25, 0, 0]){
            rounded_square(150, 55, thickness*1.1);
            //cylinder(d=55, h=thickness*1.1, center=true);
            //translate([25, 0, 0]){
            //  cube(size=[50, 50, thickness*1.1], center=true);
            //}
          //}
        }
      }
    }
  }

  //Top plate socket
  if(parts_visible_l <= 4 && parts_visible_h >= 4){
    color(c_4)
    translate([(l3+w1)/2, 0, w1-thickness/2]){
      rotate([0, 0, 0]){
        difference(){
          cube(size=[l3, w1, thickness], center=true);
          screw_holes(distance = hole_1_distance,
                       length = w1,
                       pos = (l3-thickness)/2,
                       holes = 4,
                       diameter = hole_1,
                       flip = 1,
                       mirror = 0);
          screw_holes(distance = hole_1_distance,
                       length = w1,
                       pos = l3/2-350,
                       holes = 4,
                       diameter = hole_1,
                       flip = 1,
                       mirror = 0);
          screw_holes(distance = hole_2_distance,
                       length = l3,
                       pos = 0,
                       holes = 10,
                       diameter = hole_2,
                       flip = 0,
                       mirror = 0);
        }
      }
    }
  }

  //Front plate tower
  if(parts_visible_l <= 5 && parts_visible_h >= 5){
    color(c_5)
    translate([(w1-thickness)/2, 0, l1/2]){
      rotate([0, 90, 0]){
        difference(){
          cube(size=[l2, w1, thickness], center=true);
          translate([l2/2-l7/2, 0, 0]){
            rounded_square(150, 55, thickness*1.1);
          }
          translate([-300, 0, 0]){
            rounded_square(150, 55, thickness*1.1);
          }
          screw_holes(distance = hole_1_distance,
                       length = w1,
                       pos = l2/2+thickness*1.5-300,
                       holes = 3,
                       diameter = hole_1,
                       flip = 1,
                       mirror = 0);
          screw_holes(distance = hole_1_distance,
                       length = w1,
                       pos = -l2/2-thickness*1.5+400,
                       holes = 3,
                       diameter = hole_1,
                       flip = 1,
                       mirror = 0);
          screw_holes(distance = hole_1_distance,
                       length = l2,
                       pos = (w1-thickness)/2,
                       holes = 4,
                       diameter = hole_1,
                       flip = 0,
                       mirror = 1, 
                       extra_edge = 300);
        }
      }
    }
  }

  //Side panel socket
  if(parts_visible_l <= 6 && parts_visible_h >= 6){
    color(c_6)
    translate([(l1-w1)/2, (w1+thickness)/2, w1/2]){
      rotate([90, 0, 0]){
        difference(){
          cube(size=[l1, w1, thickness], center=true);
          screw_holes(distance = hole_1_distance,
                       length = l1,
                       pos = (w1-thickness)/2,
                       holes = 15,
                       diameter = hole_1,
                       flip = 0,
                       mirror = 1);
          screw_holes(distance = hole_1_distance,
                       length = w1,
                       pos = (l1-thickness)/2,
                       holes = 4,
                       diameter = hole_1,
                       flip = 1,
                       mirror = 1);
          screw_holes(distance = hole_2_distance,
                       length = l1,
                       pos = w1/2 - 40,
                       holes = 10,
                       diameter = hole_2,
                       flip = 0,
                       mirror = 0,
                       extra_edge = -185+35);

          screw_holes(distance = hole_1_distance,
                       length = w1,
                       pos = (l1)/2-350,
                       holes = 4,
                       diameter = hole_1,
                       flip = 1,
                       mirror = 0);
          screw_holes(distance = hole_1_distance,
                       length = w1,
                       pos = (l1-thickness)/2-700,
                       holes = 4,
                       diameter = hole_1,
                       flip = 1,
                       mirror = 0);


        }
      }
    }
  }

  //inserted panel
  if(parts_visible_l <= 7 && parts_visible_h >= 7){
    color(c_7)
    translate([0, 0, w1-thickness/2]){
      rotate([0, 0, 0]){
        translate([(l7-enforce_w)/2, 0, -(thickness+enforce_h)/2]){
          difference(){
            cube(size=[enforce_w, w1, enforce_h], center=true);
            rotate([0, 90, 0])
            screw_holes(distance = hole_1_distance,
                         length = w1,
                         pos = 0,
                         holes = 4,
                         diameter = hole_1,
                         flip = 1,
                         mirror = 0);
          }
        }
        translate([0, (w1-enforce_w)/2, (thickness+enforce_h)/2]){
          cube(size=[l7, enforce_w, enforce_h], center=true);
        }
        translate([0, -(w1-enforce_w)/2, (thickness+enforce_h)/2]){
          cube(size=[l7, enforce_w, enforce_h], center=true);
        }
        difference(){
          cube(size=[l7, w1, thickness], center=true);
          screw_holes(distance = hole_1_distance,
                       length = w1,
                       pos = (l7-thickness)/2,
                       holes = 3,
                       diameter = hole_1,
                       flip = 1,
                       mirror = 0);
          screw_holes(distance = hole_1_distance,
                       length = l7,
                       pos = (w1-thickness)/2,
                       holes = 3,
                       diameter = hole_1,
                       flip = 0,
                       mirror = 1);
          translate([w1/5, w1/5, 0]){
            cylinder(d=50, h=thickness*1.1, center=true);
          }
          translate([-w1/5, -w1/5, 0]){
            cylinder(d=50, h=thickness*1.1, center=true);
          }
        }
      }
    }
  }
  
  //Side plate
  if(parts_visible_l <= 8 && parts_visible_h >= 8){
    color(c_8)
    translate([0, (w1+thickness)/2, l3/2+w1]){
      rotate([0, 90, 90]){
        difference(){
          cube(size=[l3, w1, thickness], center=true);
          screw_holes(distance = hole_1_distance,
                       length = l3,
                       pos = (w1-thickness)/2,
                       holes = 11,
                       diameter = hole_1,
                       flip = 0,
                       mirror = 1);
          screw_holes(distance = hole_1_distance,
                       length = w1,
                       pos = (l3-thickness)/2,
                       holes = 4,
                       diameter = hole_1,
                       flip = 1,
                       mirror = 1);
          screw_holes(distance = hole_1_distance,
                       length = w1,
                       pos = -(l3+thickness)/2+l4,
                       holes = 4,
                       diameter = hole_1,
                       flip = 1,
                       mirror = 0);
        }
      }
    }
  }

  //side panel top box
  if(parts_visible_l <= 9 && parts_visible_h >= 9){
    color(c_9)
    translate([w1, (w1+thickness)/2, l1-l4/2]){
      rotate([0, 90, 90]){
        translate([0, (w1-enforce_w)/2, -(thickness+enforce_h)/2]){
          cube(size=[l4-2*thickness, enforce_w, enforce_h], center=true);
        }
        color([0.0, 1.0, 1.0, 1.0]){
        }
        difference(){
          union(){
            cube(size=[l4, w1, thickness], center=true);
            translate([0, -(w1+enforce_h)/2, 0]){
              cube(size=[l4, enforce_h, enforce_w], center=true);
            }
          }
          screw_holes(distance = hole_2_distance,
                       length = l4,
                       pos = (-w1+bar_edge)/2-enforce_h,
                       holes = 6,
                       diameter = hole_2,
                       flip = 0,
                       mirror = 0);
          screw_holes(distance = hole_1_distance,
                       length = l4,
                       pos = (w1-thickness)/2,
                       holes = 5,
                       diameter = hole_1,
                       flip = 0,
                       mirror = 0);
          screw_holes(distance = hole_1_distance,
                       length = l4,
                       pos = w1/2-l7,
                       holes = 5,
                       diameter = hole_1,
                       flip = 0,
                       mirror = 0);
          screw_holes(distance = hole_1_distance,
                       length = w1,
                       pos = (l4-thickness)/2,
                       holes = 3,
                       diameter = hole_1,
                       flip = 1,
                       mirror = 1);
        }
      }
    }
  }

  //Top plate top box
  if(parts_visible_l <= 10 && parts_visible_h >= 10){
    color(c_10)
    translate([(l5-w1)/2, 0, l1-thickness/2]){
      rotate([0, 0, 0]){
        difference(){
          cube(size=[l5, w1, thickness], center=true);
          screw_holes(distance = hole_1_distance,
                       length = w1,
                       pos = l5/2-l7,
                       holes = 4,
                       diameter = hole_1,
                       flip = 1,
                       mirror = 0);
        }
      }
    }
  }

  //Front panel top box
  if(parts_visible_l <= 11 && parts_visible_h >= 11){
    color(c_11)
    translate([w1/2+l6+thickness/2, 0, l1-l4/2]){
      rotate([0, 90, 0]){
        difference(){
          cube(size=[l4, w1, thickness], center=true);
          screw_holes(distance = hole_1_distance,
                       length = w1,
                       pos = (l4-thickness)/2,
                       holes = 4,
                       diameter = hole_1,
                       flip = 1,
                       mirror = 1);
          screw_holes(distance = hole_2_distance,
                       length = l4,
                       pos = 0,
                       holes = 6,
                       diameter = hole_2,
                       flip = 0,
                       mirror = 0);
        }
      }
    }
  }

  //Bottom plate top box
  if(parts_visible_l <= 12 && parts_visible_h >= 12){
    color(c_12)
    translate([(l6+w1)/2, 0, l1-l4+thickness/2]){
      rotate([0, 0, 0]){
        cube(size=[l6, w1, thickness], center=true);
      }
    }
  }

  //inserted panel
  if(parts_visible_l <= 13 && parts_visible_h >= 13){
    color(c_13)
    translate([0, 0, l1-l4+thickness/2]){
      rotate([0, 0, 0]){
        translate([(l7-enforce_w)/2, 0, (thickness+enforce_h)/2]){
          difference(){
            cube(size=[enforce_w, w1, enforce_h], center=true);
            rotate([0, 90, 0])
            screw_holes(distance = hole_1_distance,
                         length = w1,
                         pos = 0,
                         holes = 4,
                         diameter = hole_1,
                         flip = 1,
                         mirror = 0);
          }
        }
        difference(){
          cube(size=[l7, w1, thickness], center=true);
          screw_holes(distance = hole_1_distance,
                       length = w1,
                       pos = (l7-thickness)/2,
                       holes = 4,
                       diameter = hole_1,
                       flip = 1,
                       mirror = 0);
        }
      }
    }
  }

  if(parts_visible_l <= 14 && parts_visible_h >= 14){
    color(c_14)
    translate([w1, -(w1+thickness)/2, l1-l4/2]){
      rotate([0, 90, 90]){
        translate([0, (w1-enforce_w)/2, (thickness+enforce_h)/2]){
          cube(size=[l4-2*thickness, enforce_w, enforce_h], center=true);
        }      
        color([0.0, 1.0, 1.0, 1.0]){
          translate([0, -(w1+enforce_h)/2, 0]){
            cube(size=[l4, enforce_h, enforce_w], center=true);
          }
        }
        difference(){
          cube(size=[l4, w1, thickness], center=true);
          screw_holes(distance = hole_1_distance,
                       length = l4,
                       pos = (w1-thickness)/2,
                       holes = 5,
                       diameter = hole_1,
                       flip = 0,
                       mirror = 0);
          screw_holes(distance = hole_1_distance,
                       length = l4,
                       pos = w1/2-l7,
                       holes = 5,
                       diameter = hole_1,
                       flip = 0,
                       mirror = 0);
          screw_holes(distance = hole_1_distance,
                       length = w1,
                       pos = (l4-thickness)/2,
                       holes = 3,
                       diameter = hole_1,
                       flip = 1,
                       mirror = 1);
        }
      }
    }
  }

  //Back plate
  if(parts_visible_l <= 15 && parts_visible_h >= 15){
    color(c_15)
    color([0.0, 1.0, 0.0, 1.0])
    translate([-(w1-thickness)/2, 0, l1/2]){
      rotate([0, 90, 0]){
        difference(){
          cube(size=[l2, w1, thickness], center=true);
          translate([350, 0, 0]){
            rounded_square(150, 50, thickness*1.1);
          }
          translate([50, 0, 0]){
            rounded_square(150, 50, thickness*1.1);
          }
          translate([-300, 0, 0]){
            rounded_square(150, 50, thickness*1.1);
          }
          screw_holes(distance = hole_1_distance,
                       length = w1,
                       pos = -l2/2+l4-1.5*thickness,
                       holes = 4,
                       diameter = hole_1,
                       flip = 1,
                       mirror = 0);
          screw_holes(distance = hole_1_distance,
                       length = w1,
                       pos = l2/2-300+1.5*thickness,
                       holes = 4,
                       diameter = hole_1,
                       flip = 1,
                       mirror = 0);
        }
      }
    }
  }

  if(parts_visible_l <= 16 && parts_visible_h >= 16){
    color(c_16)
    translate([0, -(w1+thickness)/2, l3/2+w1]){
      rotate([0, 90, 90]){
        difference(){
          cube(size=[l3, w1, thickness], center=true);
          screw_holes(distance = hole_1_distance,
                       length = l3,
                       pos = (w1-thickness)/2,
                       holes = 11,
                       diameter = hole_1,
                       flip = 0,
                       mirror = 1);
          screw_holes(distance = hole_1_distance,
                       length = w1,
                       pos = (l3-thickness)/2,
                       holes = 4,
                       diameter = hole_1,
                       flip = 1,
                       mirror = 1);
          screw_holes(distance = hole_1_distance,
                       length = w1,
                       pos = -(l3+thickness)/2+l4,
                       holes = 4,
                       diameter = hole_1,
                       flip = 1,
                       mirror = 0);
        }
      }
    }
  }

  //Side panel socket
  if(parts_visible_l <= 17 && parts_visible_h >= 17){
    color(c_17)
    translate([(l1-w1)/2, -(w1+thickness)/2, w1/2]){
      rotate([90, 0, 0]){
        difference(){
          cube(size=[l1, w1, thickness], center=true);
          screw_holes(distance = hole_1_distance,
                       length = l1,
                       pos = (w1-thickness)/2,
                       holes = 15,
                       diameter = hole_1,
                       flip = 0,
                       mirror = 1);
          screw_holes(distance = hole_1_distance,
                       length = w1,
                       pos = (l1-thickness)/2,
                       holes = 4,
                       diameter = hole_1,
                       flip = 1,
                       mirror = 1);
          screw_holes(distance = hole_2_distance,
                       length = l1,
                       pos = w1/2 - 40,
                       holes = 10,
                       diameter = hole_2,
                       flip = 0,
                       mirror = 0,
                       extra_edge = -140);
        }
      }
    }
  }

  //Canter bar y axis
  if(parts_visible_l <= 18 && parts_visible_h >= 18){
    color(c_18)
    translate([(l3+w1)/2, 0, w1+bar_edge/2+Y_bar_offset_center]){
      rotate([0, 0, 0]){
        difference(){
          cube(size=[bar_l1, bar_edge, bar_edge], center=true);
          screw_holes(distance = hole_2_distance,
                       length = bar_l1,
                       pos = 0,
                       holes = 10,
                       diameter = hole_2,
                       flip = 0,
                       mirror = 0,
                       extra_edge = 0);
        }
      }
    }
  }

  //Side bars Y axis
  Y_bar_offset_z = 40;
  Y_bar_offset_y = 7;
  Y_bar_offset_center = 4;
  if(parts_visible_l <= 19 && parts_visible_h >= 19){
    color(c_19)
    translate([(l3+w1)/2, (w1+thickness*3)/2+Y_bar_offset_y, w1-bar_edge/2-Y_bar_offset_z]){
      rotate([0, 0, 0]){
        difference(){
          cube(size=[bar_l1, bar_edge, bar_edge], center=true);
          rotate([90, 0, 0]){
            screw_holes(distance = hole_2_distance,
                         length = bar_l1,
                         pos = 0,
                         holes = 10,
                         diameter = hole_2,
                         flip = 0,
                         mirror = 0,
                         extra_edge = 10);
          }
        }
      }
    }
  }

  if(parts_visible_l <= 20 && parts_visible_h >= 20){
    color(c_20)
    translate([(l3+w1)/2, -((w1+thickness*3)/2+Y_bar_offset_y), w1-bar_edge/2-Y_bar_offset_z]){
      rotate([0, 0, 0]){
        difference(){
          cube(size=[bar_l1, bar_edge, bar_edge], center=true);
          rotate([90, 0, 0]){
            screw_holes(distance = hole_2_distance,
                         length = bar_l1,
                         pos = 0,
                         holes = 10,
                         diameter = hole_2,
                         flip = 0,
                         mirror = 0,
                         extra_edge = 10);
          }
        }
      }
    }
  }

  //Center bar Z axis
  Z_bar_offset_center = 10;
  if(parts_visible_l <= 21 && parts_visible_h >= 21){
    color(c_21)
    translate([w1/2+l6+thickness+bar_edge/2+Z_bar_offset_center, 0, l1-l4/2]){
      rotate([0, 90, 0]){
        difference(){
          cube(size=[bar_l5, bar_edge, bar_edge], center=true);
          screw_holes(distance = hole_2_distance,
                       length = bar_l5,
                       pos = 0,
                       holes = 6,
                       diameter = hole_2,
                       flip = 0,
                       mirror = 0,
                       extra_edge = 0);
        }
      }
    }
  }

  //Side bars Z axis
  Z_bar_offset_x=40;
  if(parts_visible_l <= 22 && parts_visible_h >= 22){
    color(c_22)
    translate([w1*1.5-bar_edge/2+Z_bar_offset_x, (w1+bar_edge)/2-thickness, l1-l4/2]){
      rotate([0, 90, 0]){
        difference(){
          cube(size=[bar_l5, bar_edge, bar_edge], center=true);
          rotate([90, 0, 0]){
            screw_holes(distance = hole_2_distance,
                         length = bar_l5,
                         pos = 0,
                         holes = 6,
                         diameter = hole_2,
                         flip = 0,
                         mirror = 0,
                         extra_edge = 0);
          }
        }
      }
    }
  }
  if(parts_visible_l <= 23 && parts_visible_h >= 23){
    color(c_23)
    translate([w1*1.5-bar_edge/2+Z_bar_offset_x, -(w1+bar_edge)/2+thickness, l1-l4/2]){
      rotate([0, 90, 0]){
        difference(){
          cube(size=[bar_l5, bar_edge, bar_edge], center=true);
          rotate([90, 0, 0]){
            screw_holes(distance = hole_2_distance,
                         length = bar_l5,
                         pos = 0,
                         holes = 6,
                         diameter = hole_2,
                         flip = 0,
                         mirror = 0,
                         extra_edge = 0);
          }
        }
      }
    }
  }
  //Mount Z motor
  if(parts_visible_l <= 24 && parts_visible_h >= 24){
    color(c_24)
    translate([400, 0, l1+bar_edge/2]){
      rotate([0, 0, 0]){
        difference(){
          cube(size=[bar_l11, bar_edge, bar_edge], center=true);
          translate([76, 0, 0]){
            cylinder(d=8, h=bar_edge * 1.1, center=true);
          }
        }
      }
    }
    color([0.7, 0.7, 0.7, 1.0])
    translate([375, 100, l1+bar_edge/2]){
      rotate([0, 0, 0]){
        cube(size=[bar_l12, bar_edge, bar_edge], center=true);
      }
    }
  }

}


//Y table ---------------------------------------------------------------------------
module y_table(){
  //Base plate
  if(parts_visible_l <= 25 && parts_visible_h >= 25){
    color(c_25)
    translate([0, 0, 0]){
      rotate([0, 0, 90]){
        difference(){
          cube(size=[l8, w1, thickness], center=true);
          screw_holes(distance = hole_2_distance,
                       length = l8,
                       pos = (w1-thickness)/2,
                       holes = 14,
                       diameter = hole_1,
                       flip = 0,
                       mirror = 1,
                       skip = 7);
            //Y bearing mounts
            translate([185, 105, 0]){
              cylinder(d=10, h=90, center=true);
            }
            translate([-185, 105, 0]){
              cylinder(d=10, h=90, center=true);
            }
            translate([-185, -105, 0]){
              cylinder(d=10, h=90, center=true);
            }
            translate([185, -105, 0]){
              cylinder(d=10, h=90, center=true);
            }
            //Fixed end mount
            translate([l8/2-bar_edge/2, 35, 0]){
              cylinder(d=10, h=90, center=true);
            }
            translate([l8/2-bar_edge/2, -35, 0]){
              cylinder(d=10, h=90, center=true);
            }
            //motor mount
            translate([-(l8/2-bar_edge/2), 35, 0]){
              cylinder(d=10, h=90, center=true);
            }
            translate([-(l8/2-bar_edge/2), -35, 0]){
              cylinder(d=10, h=90, center=true);
            }
            //Mounts center bearings
            translate([-(bearing10_d+bar_edge)/2, (w1-bearing10_d)/2, 0]){
              cylinder(d=12, h=thickness*1.1, center=true);
            }
            //Mounts center bearings
            translate([-(bearing10_d+bar_edge)/2, -(w1-bearing10_d)/2, 0]){
              cylinder(d=12, h=thickness*1.1, center=true);
            }
            
            //Holes center bar
            rotate([0, 0, 0]){
              screw_holes(distance = hole_2_distance,
                           length = l8,
                           pos = 0,
                           holes = 15,
                           diameter = hole_2,
                           flip = 0,
                           mirror = 0);
          }
        }
      }
    }
  }
    
  if(parts_visible_l <= 26 && parts_visible_h >= 26){
    //Top enforcements
    color(c_26)
    translate([(w1-thickness)/2, 0, (l10+thickness)/2]){
      rotate([0, 90, 0]){
        difference(){
          cube(size=[enforce_h, l8, enforce_w], center=true);
          translate([0, 0, 0]){
            cube(size=[enforce_h+5, 100, enforce_w+1], center=true);
          }
          rotate([0, 0, 90]){
            screw_holes(distance = hole_2_distance,
                         length = l8,
                         pos = (enforce_h-bar_edge)/2,
                         holes = 15,
                         diameter = hole_2,
                         flip = 0,
                         mirror = 0);
          }
        }
      }
    }

    color(c_26)
    translate([-(w1-thickness)/2, 0, (l10+thickness)/2]){
      rotate([0, 90, 0]){
        difference(){
          cube(size=[enforce_h, l8, enforce_w], center=true);
          translate([0, 0, 0]){
            cube(size=[enforce_h+5, 100, enforce_w+1], center=true);
          }
          rotate([0, 0, 90]){
            screw_holes(distance = hole_2_distance,
                         length = l8,
                         pos = (enforce_h-bar_edge)/2,
                         holes = 15,
                         diameter = hole_2,
                         flip = 0,
                         mirror = 0);
          }
        }
      }
    }
  }

  if(parts_visible_l <= 27 && parts_visible_h >= 27){
    //Bars
    color(c_27)
    translate([(w1+bar_edge)/2, 0, l10]){
      rotate([0, 0, 90]){
        difference(){
          cube(size=[bar_l2, bar_edge, bar_edge], center=true);
          rotate([90, 0, 0]){
            screw_holes(distance = hole_2_distance,
                         length = l8,
                         pos = 0,
                         holes = 15,
                         diameter = hole_2,
                         flip = 0,
                         mirror = 0);
          }
        }
      }
    }

    color(c_27)
    translate([-(w1+bar_edge)/2, 0, l10]){
      rotate([0, 0, 90]){
        difference(){
          cube(size=[bar_l2, bar_edge, bar_edge], center=true);
          rotate([90, 0, 0]){
            screw_holes(distance = hole_2_distance,
                         length = l8,
                         pos = 0,
                         holes = 15,
                         diameter = hole_2,
                         flip = 0,
                         mirror = 0);
          }
        }
      }
    }
    
    color(c_27)
    translate([0, 0, (thickness+bar_edge)/2+10]){
      rotate([0, 0, 90]){
        difference(){
          cube(size=[bar_l2, bar_edge, bar_edge], center=true);
          rotate([0, 0, 0]){
            screw_holes(distance = hole_2_distance,
                         length = l8,
                         pos = 0,
                         holes = 15,
                         diameter = hole_2,
                         flip = 0,
                         mirror = 0);
          }
        }
      }
    }
  }

  if(parts_visible_l <= 28 && parts_visible_h >= 28){
    //Fixed end threaded bar
    color(c_28)
    translate([0, -(l8-bar_edge)/2, (thickness+3*bar_edge)/2+10]){
      rotate([0, 0, 0]){
        cube(size=[100, bar_edge, bar_edge], center=true);
      }
    }
    color(c_28)
    translate([35, -(l8-bar_edge)/2, 25]){
      cylinder(d=8, h=80, center=true);
    }
    color(c_28)
    translate([-35, -(l8-bar_edge)/2, 25]){
      cylinder(d=8, h=80, center=true);
    }
    color([0.0, 0.7, 0.0, 1.0])//Bearing
    translate([0, -(l8+bearing6_w)/2, (thickness+3*bar_edge)/2+10]){
      rotate([90, 0, 0]){
        cylinder(d=bearing6_d, h=bearing6_w, center=true);
      }
    }
    color([0.0, 0.7, 0.0, 1.0])//Bearing
    translate([0, -(l8-bearing6_w)/2+bar_edge, (thickness+3*bar_edge)/2+10]){
      rotate([90, 0, 0]){
        cylinder(d=bearing6_d, h=bearing6_w, center=true);
      }
    }
  }

  if(parts_visible_l <= 29 && parts_visible_h >= 29){
    //Motor mount
    color(c_29)
    translate([0, (l8-bar_edge)/2, (thickness+3*bar_edge)/2+10]){
      rotate([0, 0, 0]){
        difference(){
          cube(size=[120, bar_edge, bar_edge], center=true);
          rotate([90, 0, 0]){
            cylinder(d=8, h=bar_edge*1.1, center=true);
          }
        }
      }
    }
    color(c_29)
    translate([35, (l8-bar_edge)/2, 25]){
      cylinder(d=8, h=80, center=true);
    }
    color(c_29)
    translate([-35, (l8-bar_edge)/2, 25]){
      cylinder(d=8, h=80, center=true);
    }
  }  

  if(parts_visible_l <= 30 && parts_visible_h >= 30){
    //Left bearings mount
    color(c_30)
    translate([0, -((y_bearing10_distance-bearing10_w)/2-b_x1), -b_z1a+3]){
      cube(size=[w1, bar_edge, bar_edge], center=true);
    }
    color(c_30)
    translate([-(w1-bearing10_d)/2+30, -((y_bearing10_distance-bearing10_w)/2-b_x1), -30]){
      cylinder(d=8, h=90, center=true);
    }
    color(c_30)
    translate([(w1-bearing10_d)/2-30, -((y_bearing10_distance-bearing10_w)/2-b_x1), -30]){
      cylinder(d=8, h=90, center=true);
    }
    color([0.0, 0.7, 0.0, 1.0])//Bearing
    translate([(w1-bearing10_d)/2, -((y_bearing10_distance-bearing10_w)/2-b_x1), -b_z1a]){
      rotate([90, 0, 0]){
        cylinder(d=bearing10_d, h=bearing10_w, center=true);
      }
    }
    color([0.0, 0.7, 0.0, 1.0])//Bearing
    translate([-(w1-bearing10_d)/2, -((y_bearing10_distance-bearing10_w)/2-b_x1), -b_z1a]){
      rotate([90, 0, 0]){
        cylinder(d=bearing10_d, h=bearing10_w, center=true);
      }
    }
  }


  if(parts_visible_l <= 31 && parts_visible_h >= 31){
    //Right bearings mount
    color(c_31)
    translate([0, (y_bearing10_distance-bearing10_w)/2-b_x1, -b_z1a+3]){
      cube(size=[w1, bar_edge, bar_edge], center=true);
    }
    color(c_31)
    translate([-(w1-bearing10_d)/2+30, (y_bearing10_distance-bearing10_w)/2-b_x1, -30]){
      cylinder(d=8, h=90, center=true);
    }
    color(c_31)
    translate([(w1-bearing10_d)/2-30, (y_bearing10_distance-bearing10_w)/2-b_x1, -30]){
      cylinder(d=8, h=90, center=true);
    }

    color([0.0, 0.7, 0.0, 1.0])//Bearing
    translate([(w1-bearing10_d)/2, (y_bearing10_distance-bearing10_w)/2-b_x1, -b_z1a]){
      rotate([90, 0, 0]){
        cylinder(d=bearing10_d, h=bearing10_w, center=true);
      }
    }
    color([0.0, 0.7, 0.0, 1.0])//Bearing
    translate([-(w1-bearing10_d)/2, (y_bearing10_distance-bearing10_w)/2-b_x1, -b_z1a]){
      rotate([90, 0, 0]){
        cylinder(d=bearing10_d, h=bearing10_w, center=true);
      }
    }
  }

  //Mount lead "nut"
  if(parts_visible_l <= 32 && parts_visible_h >= 32){
    //Bars
    color(c_32)
    translate([(w1+bar_edge)/2, 0, 0]){
      rotate([0, 0, 90]){
        cube(size=[bar_l7, bar_edge, bar_edge], center=true);
      }
    }
  }

      
  if(parts_visible_l <= 33 && parts_visible_h >= 33){
    //Center mount
    color(c_33)
    translate([0, (bearing10_d+bar_edge)/2+3, -b_z3a]){
      cube(size=[w1, bar_edge, bar_edge], center=true);
    }
    color(c_33)
    translate([(w1-bearing10_d)/2-35, 75, -30]){
      rotate([90, 0, 0]){
        cylinder(d=8, h=100, center=true);
      }
    }
    color(c_33)
    translate([-((w1-bearing10_d)/2-35), 75, -30]){
      rotate([90, 0, 0]){
        cylinder(d=8, h=100, center=true);
      }
    }
    //angles
    color(c_33)
    translate([w1/2-50, (bearing10_d+bar_edge)/2+50, -26]){
      difference(){
        cube(size=[bar_edge*1.7, bar_edge*1.7, bar_edge*1.7], center=true);
        translate([0, 3, -3]){
          cube(size=[bar_edge*1.8, bar_edge*1.7, bar_edge*1.7], center=true);
        }
      }
    }
    color(c_33)
    translate([w1/2-50, (bearing10_d+bar_edge)/2+90, -26]){
      difference(){
        cube(size=[bar_edge*1.7, bar_edge*1.7, bar_edge*1.7], center=true);
        translate([0, 3, -3]){
          cube(size=[bar_edge*1.8, bar_edge*1.7, bar_edge*1.7], center=true);
        }
      }
    }
    color(c_33)
    translate([-(w1/2-50), (bearing10_d+bar_edge)/2+50, -26]){
      difference(){
        cube(size=[bar_edge*1.7, bar_edge*1.7, bar_edge*1.7], center=true);
        translate([0, 3, -3]){
          cube(size=[bar_edge*1.8, bar_edge*1.7, bar_edge*1.7], center=true);
        }
      }
    }
    color(c_33)
    translate([-(w1/2-50), (bearing10_d+bar_edge)/2+90, -26]){
      difference(){
        cube(size=[bar_edge*1.7, bar_edge*1.7, bar_edge*1.7], center=true);
        translate([0, 3, -3]){
          cube(size=[bar_edge*1.8, bar_edge*1.7, bar_edge*1.7], center=true);
        }
      }
    }
    
    
    color(c_33)
    translate([(w1-bearing10_d)/2, -(bearing10_d+bar_edge)/2, -10]){
      cylinder(d=10, h=55, center=true);
    }
    color(c_33)
    translate([-(w1-bearing10_d)/2, -(bearing10_d+bar_edge)/2, -10]){
      cylinder(d=10, h=55, center=true);
    }

    //Center bearings
    color([0.0, 0.7, 0.0, 1.0])
    translate([(w1-bearing10_d)/2, -(bearing10_d+bar_edge)/2, -b_z3a]){
      cylinder(d=bearing10_d, h=bearing10_w, center=true);
    }
    color([0.0, 0.7, 0.0, 1.0])
    translate([-(w1-bearing10_d)/2, -(bearing10_d+bar_edge)/2, -b_z3a]){
      cylinder(d=bearing10_d, h=bearing10_w, center=true);
    }
    color([0.0, 0.7, 0.0, 1.0])
    translate([(w1-bearing10_d)/2, (bearing10_d+bar_edge)/2, -b_z3a]){
      cylinder(d=bearing10_d, h=bearing10_w, center=true);
    }
    color([0.0, 0.7, 0.0, 1.0])
    translate([-(w1-bearing10_d)/2, (bearing10_d+bar_edge)/2, -b_z3a]){
      cylinder(d=bearing10_d, h=bearing10_w, center=true);
    }
    
  }

}

module x_table(){  

  bowl_exit_x = l14/2-15;
  bowl_exit_y = w1/2-40;
  bowl_exit_d = 10;
  bowl_extra_x = 20;
  bowl_extra_y = 80;
  bowl_h = 50;

  //Base plate
  if(parts_visible_l <= 34 && parts_visible_h >= 34){
    color(c_34)
    translate([0, 0, 0]){
      rotate([0, 0, 90]){
        difference(){
          cube(size=[l14, w1, thickness], center=true);
          translate([bowl_exit_x, -bowl_exit_y, 0]){
            cylinder(d=bowl_exit_d, h=thickness*2, center=true);
          }
          translate([(l14-bearing10_d)/2, -(bearing10_d+bar_edge)/2, 0]){
            cylinder(d=12, h=thickness*1.1, center=true);
          }
          translate([-(l14-bearing10_d)/2, -(bearing10_d+bar_edge)/2, 0]){
            cylinder(d=12, h=thickness*1.1, center=true);
          }
          
        }
      }
    }
  }
  if(parts_visible_l <= 35 && parts_visible_h >= 35){
    //Left bearing mount
    color(c_35)
    translate([(bar_l4-bar_edge)/2, 0, 0]){
      rotate([0, 0, 90]){
        difference(){
          cube(size=[bar_l6, bar_edge, bar_edge], center=true);
          screw_holes(distance = hole_3_distance,
                       length = l8,
                       pos = 0,
                       holes = 14,
                       diameter = hole_3,
                       flip = 0,
                       mirror = 0);
          rotate([90, 0, 0]){
            screw_holes(distance = hole_3_distance*2,
                         length = l8,
                         pos = 0,
                         holes = 8,
                         diameter = hole_3,
                         flip = 0,
                         mirror = 0);
          }
        }
      }
    }
    color([0.0, 0.7, 0.0, 1.0])//Bearing
    translate([x_bearing10_distance/2-b_x2, (bar_l6-bearing10_d)/2, b_z2a-3]){
      rotate([90, 0, 90]){
        cylinder(d=bearing10_d, h=bearing10_w, center=true);
      }
    }
    color([0.0, 0.7, 0.0, 1.0])//Bearing
    translate([x_bearing10_distance/2-b_x2, -(bar_l6-bearing10_d)/2, b_z2a-3]){
      rotate([90, 0, 90]){
        cylinder(d=bearing10_d, h=bearing10_w, center=true);
      }
    }
    //Right bearing mount
    color(c_35)
    translate([-(bar_l4-bar_edge)/2, 0, 0]){
      rotate([0, 0, 90]){
        difference(){
          cube(size=[bar_l6, bar_edge, bar_edge], center=true);
          screw_holes(distance = hole_3_distance,
                       length = l8,
                       pos = 0,
                       holes = 14,
                       diameter = hole_3,
                       flip = 0,
                       mirror = 0);
          rotate([90, 0, 0]){
            screw_holes(distance = hole_3_distance*2,
                         length = l8,
                         pos = 0,
                         holes = 8,
                         diameter = hole_3,
                         flip = 0,
                         mirror = 0);
          }
        }
      }
    }
    color([0.0, 0.7, 0.0, 1.0])//Bearing
    translate([-(x_bearing10_distance/2-b_x2), (bar_l6-bearing10_d)/2, b_z2a-3]){
      rotate([90, 0, 90]){
        cylinder(d=bearing10_d, h=bearing10_w, center=true);
      }
    }
    color([0.0, 0.7, 0.0, 1.0])//Bearing
    translate([-(x_bearing10_distance/2-b_x2), -(bar_l6-bearing10_d)/2, b_z2a-3]){
      rotate([90, 0, 90]){
        cylinder(d=bearing10_d, h=bearing10_w, center=true);
      }
    }
  }

  //Center bearing mounts
  if(parts_visible_l <= 36 && parts_visible_h >= 36){
    //Center mount
    color(c_37)
    translate([-(bearing10_d+bar_edge)/2-3, 0, -b_z3a]){
      cube(size=[bar_edge, l14, bar_edge], center=true);
    }
    color(c_37)
    translate([-55, 180, -30]){
      rotate([0, 90, 0]){
        cylinder(d=8, h=80, center=true);
      }
    }
    color(c_37)
    translate([-55, -180, -30]){
      rotate([0, 90, 0]){
        cylinder(d=8, h=80, center=true);
      }
    }
    //angles
    color(c_37)
    translate([-70, 180, -26]){
      difference(){
        cube(size=[bar_edge*1.7, bar_edge*1.7, bar_edge*1.7], center=true);
        translate([-3, 0, -3]){
          cube(size=[bar_edge*1.7, bar_edge*1.8, bar_edge*1.7], center=true);
        }
      }
    }
    color(c_37)
    translate([-105, 180, -26]){
      difference(){
        cube(size=[bar_edge*1.7, bar_edge*1.7, bar_edge*1.7], center=true);
        translate([-3, 0, -3]){
          cube(size=[bar_edge*1.7, bar_edge*1.8, bar_edge*1.7], center=true);
        }
      }
    }
    color(c_37)
    translate([-70, -180, -26]){
      difference(){
        cube(size=[bar_edge*1.7, bar_edge*1.7, bar_edge*1.7], center=true);
        translate([-3, 0, -3]){
          cube(size=[bar_edge*1.7, bar_edge*1.8, bar_edge*1.7], center=true);
        }
      }
    }
    color(c_37)
    translate([-105, -180, -26]){
      difference(){
        cube(size=[bar_edge*1.7, bar_edge*1.7, bar_edge*1.7], center=true);
        translate([-3, 0, -3]){
          cube(size=[bar_edge*1.7, bar_edge*1.8, bar_edge*1.7], center=true);
        }
      }
    }
    
    
    color(c_37)
    translate([(bearing10_d+bar_edge)/2, (l14-bearing10_d)/2, -10]){
      cylinder(d=10, h=55, center=true);
    }
    color(c_37)
    translate([(bearing10_d+bar_edge)/2, -(l14-bearing10_d)/2, -10]){
      cylinder(d=10, h=55, center=true);
    }

    //Center bearings
    color([0.0, 0.7, 0.0, 1.0])
    translate([-(bearing10_d+bar_edge)/2, (l14-bearing10_d)/2, -b_z3a]){
      cylinder(d=bearing10_d, h=bearing10_w, center=true);
    }
    color([0.0, 0.7, 0.0, 1.0])
    translate([-(bearing10_d+bar_edge)/2, -(l14-bearing10_d)/2, -b_z3a]){
      cylinder(d=bearing10_d, h=bearing10_w, center=true);
    }
    color([0.0, 0.7, 0.0, 1.0])
    translate([(bearing10_d+bar_edge)/2, (l14-bearing10_d)/2, -b_z3a]){
      cylinder(d=bearing10_d, h=bearing10_w, center=true);
    }
    color([0.0, 0.7, 0.0, 1.0])
    translate([(bearing10_d+bar_edge)/2, -(l14-bearing10_d)/2, -b_z3a]){
      cylinder(d=bearing10_d, h=bearing10_w, center=true);
    }

  }

  if(parts_visible_l <= 37 && parts_visible_h >= 37){
    //Bowl
    color(c_36)
    translate([0, 0, 12]){
      rotate([0, 0, 90]){
        difference(){
          cube(size=[l14+bowl_extra_x, w1+bowl_extra_y, 1], center=true);
          translate([bowl_exit_x, -bowl_exit_y, 0]){
            cylinder(d=bowl_exit_d, h=thickness*2, center=true);
          }
          rotate([0, 0, 90]){
            for(i=[0:1:table_bar_no-1]){
              color([0.7, 0.7, 0.7, 1.0])
              translate([0, -195+i*30, 0]){
                rotate([0, 0, 0]){
                  //difference(){
                    //cube(size=[bar_l4, bar_edge, bar_edge], center=true);
                    screw_holes(distance = bar_l4 - bar_edge,
                                 length = bar_l3,
                                 pos = 0,
                                 holes = 2,
                                 diameter = hole_2,
                                 flip = 0,
                                 mirror = 0);
                  }
                //}
              }
            }
          }
        }
        translate([0, (w1+bowl_extra_y)/2, bowl_h/2]){
          cube(size=[l14+bowl_extra_x, 1, bowl_h], center=true);
        }
        translate([0, -(w1+bowl_extra_y)/2, bowl_h/2]){
          cube(size=[l14+bowl_extra_x, 1, bowl_h], center=true);
        }
        translate([(l14+bowl_extra_x)/2, 0, bowl_h/2]){
          cube(size=[1, w1+bowl_extra_y, bowl_h], center=true);
        }
        translate([-(l14+bowl_extra_x)/2, 0, bowl_h/2]){
          cube(size=[1, w1+bowl_extra_y, bowl_h], center=true);
        }
      }
    }
    
  }


  //Table
  color(c_38)
  if(parts_visible_l <= 38 && parts_visible_h >= 38){
    for(i=[0:1:table_bar_no-1]){
      translate([0, -195+i*30, 45]){
        rotate([0, 0, 0]){
          difference(){
            cube(size=[bar_l4, bar_edge, bar_edge], center=true);
            screw_holes(distance = bar_l4 - bar_edge,
                         length = bar_l3,
                         pos = 0,
                         holes = 2,
                         diameter = hole_2,
                         flip = 0,
                         mirror = 0);
          }
        }
      }
    }
  }

  //Mount lead "nut"
  if(parts_visible_l <= 39 && parts_visible_h >= 39){
    //Bars
    color(c_39)
    translate([0, -(l14+bar_edge)/2, 0]){
      rotate([0, 0, 90]){
        cube(size=[bar_edge, bar_l7, bar_edge], center=true);
      }
    }
  }
}

module z_table(){
  if(parts_visible_l <= 40 && parts_visible_h >= 40){
    //Base plate
    color(c_40)
    translate([0, 0, 0]){
      rotate([90, 0, 90]){
        difference(){
          cube(size=[l11, w3, thickness], center=true);
          translate([-25, 55, 0]){
            cylinder(d=12, h=thickness*1.1, center=true);
          }
          screw_holes(distance = hole_1_distance,
                       length = w3,
                       pos = (l11-thickness)/2,
                       holes = 3,
                       diameter = hole_1,
                       flip = 1,
                       mirror = 1);
        }
      }
    }
  }

  if(parts_visible_l <= 41 && parts_visible_h >= 41){  
    //Side guide left rear
    color(c_41)
    translate([-(bar_edge+thickness)/2, (l11-bar_edge)/2, (bar_l9-w3)/2]){
      rotate([0, 90, 90]){
        difference(){
          cube(size=[bar_l9, bar_edge, bar_edge], center=true);
          translate([-125, 4, 0]){
            rotate([0, 0, 90]){
              cylinder(d=8, h=80, center=true);
            }
          }
          translate([5, 4, 0]){
            rotate([0, 0, 90]){
              cylinder(d=8, h=80, center=true);
            }
          }
          translate([-10, 0, 0]){
            rotate([0, 90, 90]){
              cylinder(d=8, h=80, center=true);
            }
          }
          translate([-140, 0, 0]){
            rotate([0, 90, 90]){
              cylinder(d=8, h=80, center=true);
            }
          }
          translate([-165, 0, 0]){
            rotate([0, 90, 90]){
              cylinder(d=6, h=80, center=true);
            }
          }
          rotate([90, 0, 0]){
            screw_holes(distance = hole_1_distance,
                         length = w3,
                         pos = 0,
                         holes = 3,
                         diameter = hole_1,
                         flip = 0,
                         mirror = 0,
                         extra_edge = -115);
          }
        }
      }
    }
    color([0.7, 0.7, 0.7, 1.0])//Mount threat
    translate([5, (l11-bar_edge)/2, bar_l9-(w3+bar_l10)/2+70]){
      rotate([0, 90, 0]){
        cylinder(d=8, h=80, center=true);
      }
    }
    color([0.7, 0.7, 0.7, 1.0])//Mount threat
    translate([5, (l11-bar_edge)/2, bar_l9-(w3+bar_l10)/2-60]){
      rotate([0, 90, 0]){
        cylinder(d=8, h=80, center=true);
      }
    }
    color([0.0, 0.7, 0.0, 1.0])//Bearing
    translate([-(bar_edge+thickness)/2, (w1-bar_edge)/2, bar_l9-bar_l10-(w3-bearing10_d)/2]){
      rotate([0, 90, 90]){
        cylinder(d=bearing10_d, h=bearing10_w, center=true);
      }
    }
    color([0.0, 0.7, 0.0, 1.0])//Bearing
    translate([-(bar_edge+thickness)/2, (w1-bar_edge)/2, bar_l9-(w3+bearing10_d)/2]){
      rotate([0, 90, 90]){
        cylinder(d=bearing10_d, h=bearing10_w, center=true);
      }
    }

    //Side guide right rear
    color([0.7, 0.7, 0.7, 1.0])
    translate([-(bar_edge+thickness)/2, -(l11-bar_edge)/2, (bar_l9-w3)/2]){
      rotate([0, 90, 90]){
        difference(){
          cube(size=[bar_l9, bar_edge, bar_edge], center=true);
          rotate([90, 0, 0]){
            screw_holes(distance = hole_1_distance,
                         length = w3,
                         pos = 0,
                         holes = 3,
                         diameter = hole_1,
                         flip = 0,
                         mirror = 0,
                         extra_edge = -115);
          }
        }
      }
    }
    color([0.7, 0.7, 0.7, 1.0])//Mount threat
    translate([5, -(l11-bar_edge)/2, bar_l9-(w3+bar_l10)/2+70]){
      rotate([0, 90, 0]){
        cylinder(d=8, h=80, center=true);
      }
    }
    color([0.7, 0.7, 0.7, 1.0])//Mount threat
    translate([5, -(l11-bar_edge)/2, bar_l9-(w3+bar_l10)/2-60]){
      rotate([0, 90, 0]){
        cylinder(d=8, h=80, center=true);
      }
    }
    color([0.0, 0.7, 0.0, 1.0])//Bearing
    translate([-(bar_edge+thickness)/2, -(w1-bar_edge)/2, bar_l9-bar_l10-(w3-bearing10_d)/2]){
      rotate([0, 90, 90]){
        cylinder(d=bearing10_d, h=bearing10_w, center=true);
      }
    }
    color([0.0, 0.7, 0.0, 1.0])//Bearing
    translate([-(bar_edge+thickness)/2, -(w1-bar_edge)/2, bar_l9-(w3+bearing10_d)/2]){
      rotate([0, 90, 90]){
        cylinder(d=bearing10_d, h=bearing10_w, center=true);
      }
    }
  }

  if(parts_visible_l <= 42 && parts_visible_h >= 42){
    //Center guide
    color(c_42)
//    difference(){
    translate([-(bar_edge+thickness)/2-3, bar_edge/2+bearing10_d/2+3, bar_l9-(w3+bar_l10)/2]){
      rotate([0, 90, 90]){
        cube(size=[bar_l10, bar_edge, bar_edge], center=true);
      }
    }
    color(c_42)
    translate([-(bar_edge+thickness)/2-3, 70, bar_l9-w3/2-90]){
      rotate([0, 90, 90]){
        cylinder(d=8, h=110, center=true);
      }
    }
    color(c_42)
    translate([-(bar_edge+thickness)/2-3, 70, bar_l9-w3/2-220]){
      rotate([0, 90, 90]){
        cylinder(d=8, h=110, center=true);
      }
    }
//  }
    color([0.0, 0.7, 0.0, 1.0])//Bearing
    translate([-(bar_edge+thickness)/2-3, (bar_edge+bearing10_d)/2, bar_l9-(w3+bearing10_d)/2]){
      rotate([90, 0, 90]){
        cylinder(d=bearing10_d, h=bearing10_w, center=true);
      }
    }
    color([0.0, 0.7, 0.0, 1.0])//Bearing
    translate([-(bar_edge+thickness)/2-3, (bar_edge+bearing10_d)/2, bar_l9-bar_l10-(w3-bearing10_d)/2]){
      rotate([90, 0, 90]){
        cylinder(d=bearing10_d, h=bearing10_w, center=true);
      }
    }

  }
  if(parts_visible_l <= 43 && parts_visible_h >= 43){

    //Mount lead "nut"
    color([0.7, 0.7, 0.7, 1.0])
    translate([-(thickness-bar_edge)/2, 0, bar_l9-w3/2-50]){
      rotate([90, 0, 90]){
        difference(){
          cube(size=[bar_l8, bar_edge, bar_edge], center=true);
          rotate([90, 0, 0]){
            cylinder(d=12, h=bar_edge*1.1, center=true);
          }
          translate([60, 0, 0]){
            cylinder(d=6, h=bar_edge*1.1, center=true);
          }
          translate([-60, 0, 0]){
            cylinder(d=6, h=bar_edge*1.1, center=true);
          }
          translate([(bar_l8 - bar_edge)/2, 0, 0]){
            cylinder(d=6, h=bar_edge*1.1, center=true);
          }
          translate([-(bar_l8 - bar_edge)/2, 0, 0]){
            cylinder(d=6, h=bar_edge*1.1, center=true);
          }
          translate([-(bar_edge+bearing10_d)/2, 0, 0]){
            cylinder(d=10, h=50, center=true);
          }
        }
      }
    }


    color([0.0, 0.7, 0.0, 1.0])//Bearing
    translate([-(bar_edge+thickness)/2-3, -(bar_edge+bearing10_d)/2, bar_l9-w3/2-50]){
      rotate([90, 0, 90]){
        cylinder(d=bearing10_d, h=bearing10_w, center=true);
      }
    }
    
    color([0.7, 0.7, 0.7, 1.0])//Bearing threat
    translate([-5, -(bar_edge+bearing10_d)/2, bar_l9-w3/2-50]){
      rotate([90, 0, 90]){
        cylinder(d=8, h=50, center=true);
      }
    }
/*    
    color([0.0, 0.7, 0.0, 1.0])//Bearing
    translate([-(bar_edge+thickness)/2-3, -(bar_edge+bearing10_d)/2, bar_l9-bar_l10-(w3-bearing10_d)/2]){
      rotate([90, 0, 90]){
        cylinder(d=bearing10_d, h=bearing10_w, center=true);
      }
    }
    color([0.7, 0.7, 0.7, 1.0])//Bearing threat
    translate([-5, -(bar_edge+bearing10_d)/2, bar_l9-bar_l10-(w3-bearing10_d)/2]){
      rotate([90, 0, 90]){
        cylinder(d=8, h=50, center=true);
      }
    }  
*/    
  }

  if(parts_visible_l <= 44 && parts_visible_h >= 44){
    //Side guide left front
    color(c_43)
    translate([-(-2*bar_edge+thickness-bearing10_d)/2, (l11-bar_edge)/2, bar_l9-(w3+bar_l10)/2]){
      rotate([0, 90, 90]){
        difference(){
          cube(size=[bar_l10, bar_edge, bar_edge], center=true);
          translate([-70, 0, 0]){
            rotate([90, 0, 0]){
              cylinder(d=8, h=180, center=true);
            }
          }
          translate([60, 0, 0]){
            rotate([90, 0, 0]){
              cylinder(d=8, h=180, center=true);
            }
          }
        }
      }
    }
    color([0.0, 0.7, 0.0, 1.0])//Bearing
    translate([-(-2*bar_edge+thickness-bearing10_d)/2, (w1-bar_edge)/2, bar_l9-bar_l10-(w3-bearing10_d)/2]){
      rotate([0, 90, 90]){
        cylinder(d=bearing10_d, h=bearing10_w, center=true);
      }
    }
    color([0.0, 0.7, 0.0, 1.0])//Bearing
    translate([-(-2*bar_edge+thickness-bearing10_d)/2, (w1-bar_edge)/2, bar_l9-(w3+bearing10_d)/2]){
      rotate([0, 90, 90]){
        cylinder(d=bearing10_d, h=bearing10_w, center=true);
      }
    }

    //Side guide right front
    color([0.7, 0.7, 0.7, 1.0])
    translate([-(-2*bar_edge+thickness-bearing10_d)/2, -(l11-bar_edge)/2, bar_l9-(w3+bar_l10)/2]){
      rotate([0, 90, 90]){
        cube(size=[bar_l10, bar_edge, bar_edge], center=true);
      }
    }
    color([0.0, 0.7, 0.0, 1.0])//Bearing
    translate([-(-2*bar_edge+thickness-bearing10_d)/2, -(w1-bar_edge)/2, bar_l9-bar_l10-(w3-bearing10_d)/2]){
      rotate([0, 90, 90]){
        cylinder(d=bearing10_d, h=bearing10_w, center=true);
      }
    }
    color([0.0, 0.7, 0.0, 1.0])//Bearing
    translate([-(-2*bar_edge+thickness-bearing10_d)/2, -(w1-bar_edge)/2, bar_l9-(w3+bearing10_d)/2]){
      rotate([0, 90, 90]){
        cylinder(d=bearing10_d, h=bearing10_w, center=true);
      }
    }
  }

  if(parts_visible_l <= 45 && parts_visible_h >= 45){


    //Mount lead "nut"
    color([0.7, 0.7, 0.7, 1.0])
    translate([(thickness+4)/2, 0, bar_l9-w3/2-75]){
      rotate([90, 0, 90]){
        difference(){
          cube(size=[140, bar_edge, 4], center=true);
          translate([(bar_l8 - bar_edge)/2, 0, 0]){
            cylinder(d=6, h=bar_edge*1.1, center=true);
          }
          translate([-(bar_l8 - bar_edge)/2, 0, 0]){
            cylinder(d=6, h=bar_edge*1.1, center=true);
          }
          translate([-60, 1, 0]){
            cylinder(d=6, h=50, center=true);
          }
          translate([60, 1, 0]){
            cylinder(d=6, h=50, center=true);
          }
          translate([-40, 1, 0]){
            cylinder(d=6, h=50, center=true);
          }
          translate([40, 1, 0]){
            cylinder(d=6, h=50, center=true);
          }
          translate([-20, 1, 0]){
            cylinder(d=6, h=50, center=true);
          }
          translate([20, 1, 0]){
            cylinder(d=6, h=50, center=true);
          }
        }
      }
    }
    color([0.7, 0.7, 0.7, 1.0])
    translate([-(thickness-4)/2, 0, bar_l9-w3/2-75]){
      rotate([90, 0, 90]){
        difference(){
          cube(size=[100, bar_edge, 4], center=true);
          translate([(bar_l8 - bar_edge)/2, 0, 0]){
            cylinder(d=6, h=bar_edge*1.1, center=true);
          }
          translate([-(bar_l8 - bar_edge)/2, 0, 0]){
            cylinder(d=6, h=bar_edge*1.1, center=true);
          }
          translate([-40, 1, 0]){
            cylinder(d=6, h=50, center=true);
          }
          translate([40, 1, 0]){
            cylinder(d=6, h=50, center=true);
          }
          translate([-20, 1, 0]){
            cylinder(d=6, h=50, center=true);
          }
          translate([20, 1, 0]){
            cylinder(d=6, h=50, center=true);
          }
        }
      }
    }


    color([0.7, 0.7, 0.7, 1.0])
    translate([+(thickness+12)/2, 60, bar_l9-w3/2-62.5]){
      rotate([90, 0, 90]){
        difference(){
          cube(size=[bar_edge, 45, 4], center=true);
          translate([(bar_l8 - bar_edge)/2, 0, 0]){
            cylinder(d=6, h=bar_edge*1.1, center=true);
          }
          translate([-(bar_l8 - bar_edge)/2, 0, 0]){
            cylinder(d=6, h=bar_edge*1.1, center=true);
          }
          translate([0, 12.5, 0]){
            cylinder(d=6, h=50, center=true);
          }
          translate([0, -12.5, 0]){
            cylinder(d=6, h=50, center=true);
          }
        }
      }
    }


    color([0.7, 0.7, 0.7, 1.0])
    translate([+(thickness+12)/2, -60, bar_l9-w3/2-62.5]){
      rotate([90, 0, 90]){
        difference(){
          cube(size=[bar_edge, 45, 4], center=true);
          translate([(bar_l8 - bar_edge)/2, 0, 0]){
            cylinder(d=6, h=bar_edge*1.1, center=true);
          }
          translate([-(bar_l8 - bar_edge)/2, 0, 0]){
            cylinder(d=6, h=bar_edge*1.1, center=true);
          }
          translate([0, 12.5, 0]){
            cylinder(d=6, h=50, center=true);
          }
          translate([0, -12.5, 0]){
            cylinder(d=6, h=50, center=true);
          }
        }
      }
    }


  }


}

module rounded_square(edge=100, corner=10, height=10){
  cube(size=[edge-corner, edge, height], center=true);
  cube(size=[edge, edge-corner, height], center=true);
  translate([(edge-corner)/2, (edge-corner)/2, 0]){
    cylinder(d=corner, h=height, center=true);
  }
  translate([-(edge-corner)/2, (edge-corner)/2, 0]){
    cylinder(d=corner, h=height, center=true);
  }
  translate([-(edge-corner)/2,-(edge-corner)/2, 0]){
    cylinder(d=corner, h=height, center=true);
  }
  translate([(edge-corner)/2, -(edge-corner)/2, 0]){
    cylinder(d=corner, h=height, center=true);
  }
}
